/**************************************************************
 *  File Name:  FINDLOG.C
 *
 *  Purpose:  Writes the natural log of the two variables
 *	passed to the file specified on the command line.
 * 	This program was written for use with an arc/info
 *	AML, because there is no log function in the AML
 *	language.
 *
 *  Programmer:  Barbara Marks
 *
 *  Date:  December, 1991
 **************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


void main(argc,argv)
int	argc;
char	*argv[];
{

	float	var1,var2;
	float   log_var1,log_var2;
	char	filename[60];
	FILE	*fp;


/*
 *  Get the three arguments passed.
 */
	var1 = atof (argv[1]);        /* value 1         */
	var2 = atof (argv[2]);        /* value 2         */
	strcpy (filename,argv[3]);    /* output filename */

/*
 *  Get the log of these values.
 */
	log_var1 = log((double)var1);
	log_var2 = log((double)var2);

/*
 *  Write the log values to the file "filename", one value
 *  per record.
 */
	if ((fp = fopen(filename,"w")) == NULL) {
	   printf ("\nERROR! Can not open file: %s\n",filename);
	   exit(-1);
	}

	fprintf (fp,"%f\n",log_var1);
	fprintf (fp,"%f\n",log_var2);

	fclose (fp);
}
